## edk2 2025.11

=== debian/changelog ===
edk2 (2025.11-3) unstable; urgency=medium

  * d/tests/control: restrict qemu-system-x86-64 dependency to 64-bit
    architectures.
  * Enable salsa-ci.

 -- dann frazier <dannf@debian.org>  Thu, 08 Jan 2026 13:58:16 -0700

edk2 (2025.11-2) unstable; urgency=medium

  * d/tests/control: restore dependency on qemu-system-aarch64
    (Closes: #1124579)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 03 Jan 2026 13:42:49 +0300

edk2 (2025.11-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202511 tag.
    - Refresh patches:
      + no-stack-protector-all-archs.diff
      + brotlicompress-disable.diff
      + x64-baseline-abi.patch
      + fix_nasm_compile.patch
    - Clear keyboard queue buffer to avoid leaking the password
      string, CVE-2024-38798. (Closes: #1122288)
  * Remove qemu-efi-arm, upstream has removed support for it.
  * Remove ovmf-ia32, upstream has removed support for it.
  * Split ovmf out into ovmf-generic, ovmf-amdsev, ovmf-inteltdx,
    and transition ovmf into a metapackage that depends on each
    of them. This lets users install only the packages that are
    usable on their CPUs.
  * d/control, d/tests/control: Use architecture-specific qemu-system
    virtual packages.

 -- dann frazier <dannf@debian.org>  Sun, 21 Dec 2025 18:44:07 -0700
