=== debian/control ===
Source: edk2
Section: misc
Priority: optional
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: dann frazier <dannf@debian.org>
Build-Depends: bc,
 debhelper-compat (= 12),
 dosfstools [amd64 arm64] <!nocheck>,
 dpkg (>= 1.19.3),
 gcc-aarch64-linux-gnu,
 gcc-multilib [i386],
 gcc-riscv64-linux-gnu,
 gcc-loongarch64-linux-gnu,
 grub-efi-amd64-signed [amd64] <!nocheck>,
 grub-efi-arm64-signed [arm64] <!nocheck>,
 iasl,
 lsb-release,
 mtools [amd64 arm64] <!nocheck>,
 nasm,
 openssl [amd64 arm64] <!nocheck>,
 python3,
 python3-pexpect <!nocheck>,
 python3-virt-firmware,
 qemu-system-aarch64,
 qemu-system-loongarch64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64] <!nocheck>,
 qemu-system-riscv64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64] <!nocheck>,
 qemu-system-x86-64 <!nocheck>,
 rsync,
 sbsigntool [amd64 arm64] <!nocheck>,
 shim-signed [amd64 arm64] <!nocheck>,
 uuid-dev,
 xorriso [amd64 arm64] <!nocheck>,
Standards-Version: 4.5.0
Homepage: http://www.tianocore.org
Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git
Vcs-Browser: https://salsa.debian.org/qemu-team/edk2
XS-Build-Indep-Architecture: amd64

Package: ovmf
Architecture: all
Depends:
 ovmf-amdsev,
 ovmf-generic,
 ovmf-inteltdx
 ${misc:Depends}
Multi-Arch: foreign
Description: UEFI firmware for 64-bit x86 virtual machines
 Open Virtual Machine Firmware is a build of EDK II for 64-bit x86 virtual
 machines. It includes full support for UEFI, including Secure Boot, allowing
 use of UEFI in place of a traditional BIOS in your VM.
 .
 This metapackage provides all of the OVMF variants, including those that
 require CPU-specific features.

Package: ovmf-generic
Architecture: all
Depends: ${misc:Depends}
Replaces: ovmf (<<2025.11~)
Breaks: ovmf (<<2025.11~)
Suggests: qemu-system-x86-64
Multi-Arch: foreign
Description: UEFI firmware for 64-bit x86 virtual machines
 Open Virtual Machine Firmware is a build of EDK II for 64-bit x86 virtual
 machines. It includes full support for UEFI, including Secure Boot, allowing
 use of UEFI in place of a traditional BIOS in your VM.
 .
 This package provides images that do not require specific CPU support. They
 can be booted in a fully-emulated mode, or accelerated with KVM on supported
 CPUs.

Package: ovmf-amdsev
Architecture: all
Depends: ${misc:Depends}
Replaces: ovmf (<<2025.11~)
Breaks: ovmf (<<2025.11~)
Suggests: qemu-system-x86-64
Multi-Arch: foreign
Description: UEFI firmware for AMD SEV-SNP confidential virtual machines
 Open Virtual Machine Firmware builds of EDK II for confidential computing
 virtual machines on host CPUs that support AMD SEV-SNP.

Package: ovmf-inteltdx
Architecture: all
Depends: ${misc:Depends}
Replaces: ovmf (<<2025.11~)
Breaks: ovmf (<<2025.11~)
Suggests: qemu-system-x86-64
Multi-Arch: foreign
Description: UEFI firmware for Intel TDX confidential virtual machines
 Open Virtual Machine Firmware builds of EDK II for confidential computing
 virtual machines on host CPUs that support Intel TDX.

Package: qemu-efi-aarch64
Architecture: all
Depends: ${misc:Depends}
Breaks: qemu-efi (<< 0~20161202.7bbe0b3e-2)
Suggests: qemu-system-aarch64
Multi-Arch: foreign
Description: UEFI firmware for 64-bit ARM virtual machines
 qemu-efi-aarch64 is a build of EDK II for 64-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi-riscv64
Architecture: all
Depends: ${misc:Depends}
Suggests: qemu-system-riscv64
Multi-Arch: foreign
Description: UEFI firmware for RISCV64 virtual machines
 qemu-efi-riscv64 is a build of EDK II for RISCV64 virtual machines.

Package: qemu-efi-loongarch64
Architecture: all
Depends: ${misc:Depends}
Suggests: qemu-system-loongarch64
Multi-Arch: foreign
Description: UEFI firmware for LoongArch64 virtual machines
 qemu-efi-loongarch64 is a build of EDK II for LoongArch64 virtual machines.

Package: efi-shell-x64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit x86 architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellx64.efi binary for the 64-bit x86
 architecture.

Package: efi-shell-aa64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit ARM architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellaa64.efi binary for the 64-bit ARM
 architecture.

Package: efi-shell-riscv64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit RISC-V architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellriscv64.efi binary for the 64-bit RISC-V
 architecture.

Package: efi-shell-loongarch64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit LoongArch architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellloongarch64.efi binary for the 64-bit LoongArch
 architecture.
