=== debian/rules ===
#!/usr/bin/make -f

SHELL=/bin/bash

include /usr/share/dpkg/default.mk
include /usr/share/dpkg/buildopts.mk

# Set to DEBUG for debug builds
BUILD_TYPE ?= RELEASE
EDK2_TOOLCHAIN = GCC5
export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
export $(EDK2_TOOLCHAIN)_RISCV64_PREFIX=riscv64-linux-gnu-
export $(EDK2_TOOLCHAIN)_LOONGARCH64_PREFIX=loongarch64-linux-gnu-

export PYTHON3_ENABLE=TRUE

ifeq ($(DEB_BUILD_ARCH),amd64)
	EDK2_BUILD_ARCH=X64
endif
ifeq ($(DEB_BUILD_ARCH),arm64)
	EDK2_BUILD_ARCH=AARCH64
endif

# LP: #2078252
unexport ELF_PACKAGE_METADATA

PCD_RELEASE_DATE = $(shell date -d@$(SOURCE_DATE_EPOCH) "+%m/%d/%Y")
PCD_FLAGS  = --pcd PcdFirmwareVendor=L"$(shell lsb_release -is) distribution of EDK II\\0"
PCD_FLAGS += --pcd PcdFirmwareVersionString=L"$(DEB_VERSION)\\0"
PCD_FLAGS += --pcd PcdFirmwareReleaseDateString=L"$(PCD_RELEASE_DATE)\\0"
COMMON_FLAGS  = -DCC_MEASUREMENT_ENABLE=TRUE
COMMON_FLAGS += -DNETWORK_HTTP_BOOT_ENABLE=TRUE
COMMON_FLAGS += -DNETWORK_IP6_ENABLE=TRUE
COMMON_FLAGS += -DNETWORK_TLS_ENABLE
COMMON_FLAGS += $(PCD_FLAGS)

NO_STRICTNX_COMMON_FLAGS = --pcd PcdUninstallMemAttrProtocol=TRUE

OVMF_COMMON_FLAGS  = $(COMMON_FLAGS)
OVMF_COMMON_FLAGS += -DTPM2_ENABLE=TRUE
# Uncomment for in-band debug messages
# OVMF_COMMON_FLAGS += "-DDEBUG_ON_SERIAL_PORT=TRUE"
OVMF_4M_COMMON_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
OVMF_4M_NO_SECBOOT_FLAGS = $(OVMF_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS)
OVMF_4M_SECBOOT_FLAGS = $(OVMF_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE
OVMF_4M_SECBOOT_CC_FLAGS = $(OVMF_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=FALSE
OVMF_4M_SECBOOT_STRICTNX_FLAGS = $(OVMF_4M_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE
OVMF32_4M_COMMON_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
OVMF32_4M_NO_SECBOOT_FLAGS = $(OVMF32_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS)
OVMF32_4M_SECBOOT_FLAGS = $(OVMF32_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE
OVMF32_4M_SECBOOT_STRICTNX_FLAGS = $(OVMF32_4M_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE

AAVMF_COMMON_FLAGS  = $(COMMON_FLAGS)
AAVMF_COMMON_FLAGS += -DTPM2_ENABLE=TRUE
AAVMF_COMMON_FLAGS += -DTPM2_CONFIG_ENABLE=TRUE
AAVMF_COMMON_FLAGS += -DCAVIUM_ERRATUM_27456=TRUE
AAVMF_NO_SECBOOT_FLAGS = $(COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS)
AAVMF_SECBOOT_FLAGS = $(AAVMF_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE
AAVMF_SECBOOT_STRICTNX_FLAGS = $(AAVMF_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE

RISCV64_FLAGS = $(COMMON_FLAGS)
LOONGARCH64_FLAGS = $(COMMON_FLAGS)

# Clear variables used internally by the edk2 build system
undefine WORKSPACE
undefine ECP_SOURCE
undefine EDK_SOURCE
undefine EFI_SOURCE
undefine EDK_TOOLS_PATH
undefine CONF_PATH

DESTDIR ?= $(CURDIR)/debian/tmp

%:
	dh $@

override_dh_auto_install:
	$(MAKE) -f debian/rules -j$(DEB_BUILD_OPTION_PARALLEL) install-all

override_dh_auto_build:
	$(MAKE) -f debian/rules -j$(DEB_BUILD_OPTION_PARALLEL) build-all

override_dh_auto_test: override_dh_auto_install
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -f debian/rules -j$(DEB_BUILD_OPTION_PARALLEL) test-all
endif

OVMF_INSTALL_DIR = $(DESTDIR)/usr/share/OVMF
ovmf_INSTALL_DIR = $(DESTDIR)/usr/share/ovmf
OVMF_SHELL_INSTALL_DIR = $(DESTDIR)/usr/share/efi-shell-x64
OVMF64_BUILD_ROOT = Build/OvmfX64
OVMF64_BUILD_DIR = $(OVMF64_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
AMDSEV_BUILD_ROOT = Build/AmdSev
AMDSEV_BUILD_DIR = $(AMDSEV_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
INTELTDX_BUILD_ROOT = Build/IntelTdx
INTELTDX_BUILD_DIR = $(INTELTDX_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)

AAVMF_INSTALL_DIR = $(DESTDIR)/usr/share/AAVMF
AAVMF_SHELL_INSTALL_DIR = $(DESTDIR)/usr/share/efi-shell-aa64
AAVMF_BUILD_ROOT = Build/ArmVirtQemu-AArch64
AAVMF_BUILD_DIR = $(AAVMF_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)

RISCV64_INSTALL_DIR = $(DESTDIR)/usr/share/qemu-efi-riscv64
RISCV64_SHELL_INSTALL_DIR = $(DESTDIR)/usr/share/efi-shell-riscv64
RISCV64_BUILD_ROOT = Build/RiscVVirtQemu
RISCV64_BUILD_DIR = $(RISCV64_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)

LOONGARCH64_INSTALL_DIR = $(DESTDIR)/usr/share/qemu-efi-loongarch64
LOONGARCH64_SHELL_INSTALL_DIR = $(DESTDIR)/usr/share/efi-shell-loongarch64
LOONGARCH64_BUILD_ROOT = Build/LoongArchVirtQemu
LOONGARCH64_BUILD_DIR = $(LOONGARCH64_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)

# -j options in MAKEFLAGS cause the edk2 build system to fall over.
MAKEFLAGS_NO_PARALLEL := $(filter-out -j%,$(MAKEFLAGS))
# If a parallel build was requested, we'll build multiple images in parallel.
# Tell each image build to just use one thread to avoid overload.
ifneq ($(MAKEFLAGS),$(MAKEFLAGS_NO_PARALLEL))
	MAX_CONCURRENT_THREAD_NUMBER ?= 1
	# This var doesn't seem to be respected, so we explicitly
        # pass "-n" instead.
	#export MAX_CONCURRENT_THREAD_NUMBER
	MAX_THREADS_ARG = -n $(MAX_CONCURRENT_THREAD_NUMBER)
endif

define edksetup
	rm $(2)/Conf/BuildEnv.sh
	sed "s|$(1)|$(2)|g" < $(1)/Conf/BuildEnv.sh > $(2)/Conf/BuildEnv.sh
endef

define do_build
	rm -rf debian/build/$(1)/$(2)
	mkdir -p debian/build/$(1)/$(2)
	rsync -aH --link-dest=$(CURDIR) \
		--exclude=/.git/ --exclude=/debian/ \
		./ debian/build/$(1)/$(2)/
	$(call edksetup,$(CURDIR),$(CURDIR)/debian/build/$(1)/$(2))
	cd debian/build/$(1)/$(2) && . edksetup.sh; \
		export MAKEFLAGS=$(MAKEFLAGS_NO_PARALLEL); \
		build -a $(3) -t $(EDK2_TOOLCHAIN) \
		-p $(4) $(5) -b $(BUILD_TYPE) $(MAX_THREADS_ARG)
endef

define install_descriptors
	mkdir -p $(DESTDIR)/usr/share/qemu/firmware
	cp debian/descriptors/$(1) $(DESTDIR)/usr/share/qemu/firmware
endef

SHELL_ARCHS = aa64 loongarch64 riscv64 x64

.PHONY: install-all build-all test-all
install-all: install-qemu-efi-aarch64 install-ovmf install-qemu-efi-riscv64 install-qemu-efi-loongarch64 $(addprefix install-efi-shell-,$(SHELL_ARCHS)) $(AAVMF_PREENROLLED_VARS) $(OVMF64_PREENROLLED_VARS)
build-all: build-qemu-efi-aarch64 build-ovmf build-qemu-efi-riscv64 build-qemu-efi-loongarch64 $(addprefix build-efi-shell-,$(SHELL_ARCHS))
test-all: export PYTHONPATH=$(CURDIR)/debian/python
test-all: export DEB_EDK2_ROOT=$(DESTDIR)
test-all:
	./debian/tests/shell.py
	./debian/tests/check-descriptors.sh

debian/setup-build-stamp:
	set -e; . ./edksetup.sh; \
	make -C BaseTools ARCH=$(EDK2_BUILD_ARCH)
	touch $@

## OVMF ##
.PHONY: install-ovmf build-ovmf
install-ovmf: install-ovmf-no-secboot install-ovmf-secboot install-ovmf-secboot-strictnx install-ovmf-amdsev install-ovmf-inteltdx-ms
build-ovmf: build-ovmf-no-secboot build-ovmf-secboot build-ovmf-secboot-strictnx build-ovmf-amdsev build-ovmf-inteltdx-ms

# OVMF NO-SECBOOT AND SHELL
OVMF64_NO_SECBOOT_BUILD_DIR = debian/build/ovmf/no-secboot/$(OVMF64_BUILD_DIR)
.PHONY: install-ovmf-no-secboot install-efi-shell-x64 build-ovmf-no-secboot build-efi-shell-x64
install-ovmf-no-secboot: build-ovmf-no-secboot
	mkdir -p $(OVMF_INSTALL_DIR)
	cp $(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF_INSTALL_DIR)/OVMF_CODE_4M.fd
	cp $(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF_VARS.fd \
		$(OVMF_INSTALL_DIR)/OVMF_VARS_4M.fd
	mkdir -p $(ovmf_INSTALL_DIR)
	cp $(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF.fd $(ovmf_INSTALL_DIR)
	$(call install_descriptors,*-edk2-x86_64.json)

install-efi-shell-x64: build-efi-shell-x64
	mkdir -p $(OVMF_SHELL_INSTALL_DIR)
	cp $(OVMF64_NO_SECBOOT_BUILD_DIR)/X64/Shell.efi \
		$(OVMF_SHELL_INSTALL_DIR)/shellx64.efi

build-ovmf-no-secboot: $(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF.fd $(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF_CODE.fd
build-efi-shell-x64: $(OVMF64_NO_SECBOOT_BUILD_DIR)/X64/Shell.efi
$(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF.fd $(OVMF64_NO_SECBOOT_BUILD_DIR)/FV/OVMF_CODE.fd $(OVMF64_NO_SECBOOT_BUILD_DIR)/X64/Shell.efi &: debian/setup-build-stamp
