=== debian/tests/control ===
Test-Command: PYTHONPATH=./debian/python python3 debian/tests/shell.py
Restrictions: allow-stderr
Depends:
 dosfstools [amd64 arm64],
 grub-efi-amd64-signed [amd64],
 grub-efi-arm64-signed [arm64],
 mtools [amd64 arm64],
 openssl [amd64 arm64],
 ovmf [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 python3-pexpect,
 python3-virt-firmware,
 qemu-efi-aarch64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 qemu-efi-loongarch64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 qemu-efi-riscv64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 qemu-system-aarch64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 qemu-system-loongarch64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 qemu-system-riscv64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 qemu-system-x86-64 [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 sbsigntool [amd64 arm64],
 shim-signed [amd64 arm64],
 xorriso [amd64 arm64],

Test-Command: ./debian/tests/check-descriptors.sh
Depends:
  jq,
  ovmf,

Test-Command: ./debian/tests/check-descriptors.sh
Depends:
  jq,
  qemu-efi-aarch64,

Test-Command: ./debian/tests/check-descriptors.sh
Depends:
  jq,
  qemu-efi-loongarch64,

Test-Command: ./debian/tests/check-descriptors.sh
Depends:
  jq,
  qemu-efi-riscv64,
